=== debian/changelog ===
freediameter (1.2.1-8) unstable; urgency=medium

  * Team upload
  * CVE-2020-6098 (Closes: #985088)
    Anybody can send a specially crafted Diameter request, which triggers
    a memory corruption and thus results in a denial-of-service.

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 22 Mar 2021 18:03:02 +0100

freediameter (1.2.1-7) unstable; urgency=medium

  * Build using "old" SCTP API since the new one fails to build in Debian
    unstable (Closes: #910440)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 14 Oct 2018 10:26:18 +0200

freediameter (1.2.1-6) unstable; urgency=medium

  * debian/rules:
    - Test suite fails randomly on more architectures, so skipping entirely

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 04 Sep 2018 19:51:42 +0200

freediameter (1.2.1-5) unstable; urgency=medium

  * debian/rules:
    - skip test suite on s390x because of problems with the test suite

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 04 Sep 2018 07:00:51 +0200

freediameter (1.2.1-4) unstable; urgency=medium

  * debian/control:
    - Added more dependencies for libfreediameter-dev:
        libgnutls28-dev, libgcrypt20-dev, libidn11-dev, libsctp-dev
    - 'freediameter' changed to arch: all and Multi-Arch: foreign.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Mon, 03 Sep 2018 22:13:39 +0200

freediameter (1.2.1-3) unstable; urgency=medium

  * debian/*.install:
    - Move freeDiameter.conf from libfdcore6 to freediameterd.
  * debian/control:
    - freediameter now "Multi-Arch: same"
    - libfreediameter-dev not "Multi-Arch: same" anymore because of
      freeDiameter-host.h
    - Handle moved file using Breaks and Replaces
  * debian/tests/control:
    - Test depends on "build-essential"

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 02 Sep 2018 20:32:05 +0200

freediameter (1.2.1-2) unstable; urgency=medium

  * d/patches/0004-Disable-running-tests-that-require-the-kernel-module.patch:
    - Fix FTBFS because of build machine not having loaded the 'sctp' kernel
      module
  * d/control:
    - New standards version 4.2.1 - no changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 26 Aug 2018 10:41:29 +0200

freediameter (1.2.1-1) unstable; urgency=low

  * Initial release (Closes: #904219)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 25 Aug 2018 14:49:27 +0200
