=== debian/tests/control ===
Tests: can-link
Depends: libfreediameter-dev, build-essential
