=== debian/changelog ===
freediameter (1.5.0-2) unstable; urgency=medium

  * fix gcc15 build (Closes: #1096650)

 -- Victor Seva <vseva@debian.org>  Thu, 11 Sep 2025 21:26:29 +0200

freediameter (1.5.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Remove obsolete field Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Remove constraints unnecessary since buster (oldstable)

  [ Thorsten Alteholz ]
  * add salsa-ci.yml

  [ Helmut Grohne ]
  * Fix FTCBFS: Use the host architecture strip. (Closes: #985796)

  [ Vagrant Cascadian ]
  * debian/rules: fix reproducible build (Closes: #1001854)

  [ Victor Seva ]
  * debian: add watch file
  * debian: repository is now in github
  * wrap-and-sort -sat
  * gbp.conf: don't import .github files
  * gbp.conf: use [debian|upstream]/latest following DEP-14
  * Use secure URI in Homepage field.
  * New upstream version 1.5.0
  * refresh and remove patches
  * add myself as uploader
  * update symbols
  * pkg-config => pkgconf
  * update manpage with new options
  * remove explicit dependency on freediameter-extensions

  [ Simon Josefsson ]
  * Depend on libidn-dev instead of libidn11-dev. Closes: #1066848.

 -- Victor Seva <vseva@debian.org>  Fri, 31 Jan 2025 17:21:14 +0100
