=== debian/control ===
Source: freediameter
Maintainer: Debian Mobcom Maintainers <Debian-mobcom-maintainers@lists.alioth.debian.org>
Uploaders:
 Ruben Undheim <ruben.undheim@gmail.com>,
 Victor Seva <vseva@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 13),
 flex,
 libgcrypt20-dev,
 libgnutls28-dev,
 libidn-dev,
 libsctp-dev,
 pkgconf,
 txt2man,
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debian-mobcom-team/freediameter
Vcs-Git: https://salsa.debian.org/debian-mobcom-team/freediameter.git
Homepage: https://www.freediameter.net/trac/

Package: libfdproto6
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: Library for manipulating Diameter messages and dictionary
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol
 .
 The shared library libfdproto provides the functions to manipulate Diameter
 messages and dictionary. This library is meant to be re-used by other projects
 that would require parsing or manipulating Diameter messages.

Package: libfdcore6
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: FreeDiameter - library for the Diameter protocol
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 This shared library contains the core of the framework. It establishes the
 network connections with other Diameter peers and performs the tasks described
 in Diameter Base Protocol, such as watchdogs, basic routing, ... It also
 handles the loading of extensions (see below)

Package: libfreediameter-dev
Architecture: any
Section: libdevel
Depends:
 libfdcore6 (= ${binary:Version}),
 libfdproto6 (= ${binary:Version}),
 libgcrypt20-dev,
 libgnutls28-dev,
 libidn-dev,
 libsctp-dev,
 ${misc:Depends},
Description: Library for the Diameter protocol (development files)
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 This shared library contains the development files for libfdcoreX and
 libfdprotoX

Package: freediameterd
Architecture: any
Section: utils
Depends:
 libfdcore6 (= ${binary:Version}),
 libfdproto6 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Daemon for the Diameter protocol
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 This simple daemon parses the command line and initializes the freeDiameter
 framework. Use it for your Diameter server & agent components.  In case of
 Diameter clients, you probably will prefer linking the libfdcore directly with
 your client application that must be made Diameter-aware.

Package: freediameter-extensions
Architecture: any
Depends:
 libfdcore6 (= ${binary:Version}),
 libfdproto6 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Extensions for the Diameter protocol
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 The extensions provide the mean to augment the features of the freeDiameterd
 framework. Extensions can provide the handling of a Diameter server
 application, but also advanced routing features, peer management, etc.

Package: freediameter
Architecture: all
Section: utils
Depends:
 freediameter-extensions,
 freediameterd,
 ${misc:Depends},
Multi-Arch: foreign
Description: Implementation of the freeDiameter protocol - metapackage
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 This is a metapackage which will install the shared libraries, the daemon
 and the extensions for freeDiameter.
